'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VideoAudioPreview = exports.VideoPreview = exports.VideoVUMeter = exports.Video = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.Preview = Preview;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

navigator.getMedia = navigator.getUserMedia;
var defaultVideoId = "webcam-preview";

function Preview(WrappedComponent) {
  return function (_Component) {
    _inherits(_class, _Component);

    function _class(props) {
      _classCallCheck(this, _class);

      var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

      _this.videoBooted = false;
      _this.meterEnabled = false;
      _this.stream = null;
      _this.audioContext = null;
      _this.state = {
        vuMeter: 0
      };

      _this.attachAudioAnalyser = _this.attachAudioAnalyser.bind(_this);
      _this.setupMedia = _this.setupMedia.bind(_this);
      return _this;
    }

    _createClass(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.setupMedia();
      }
    }, {
      key: 'componentWillUpdate',
      value: function componentWillUpdate(nextProps, nextState) {
        var isSetupNeeded = !this.meterEnabled && !this.videoBooted;
        var isNewSelectedDevices = this.props.selectedAudio != nextProps.selectedAudio || this.props.selectedVideo != nextProps.selectedVideo;
        var isAudioAndVideoSelected = !!nextProps.selectedAudio || !!nextProps.selectedVideo;
        if ((isSetupNeeded || isNewSelectedDevices) && isAudioAndVideoSelected) this.setupMedia(nextProps);
      }
    }, {
      key: 'stopMedia',
      value: function stopMedia(stream) {
        if (typeof stream == 'function') {
          stream.stop();
        } else {
          if (stream.active) {
            var tracks = stream.getTracks();
            tracks.forEach(function (track) {
              track.stop();
            });
          }
        }
      }
    }, {
      key: 'setupMedia',
      value: function setupMedia() {
        var _this2 = this;

        var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

        var gProps = props || this.props;
        var audio = gProps.audio,
            options = gProps.options,
            videoId = gProps.videoId,
            selectedAudio = gProps.selectedAudio,
            selectedVideo = gProps.selectedVideo;

        var videoEl = document.getElementById(videoId || defaultVideoId);
        var streamOptions = {
          audio: audio || false,
          video: true,
          mirrored: true,
          options: options || {}
        };
        if (selectedAudio !== 'none') {
          streamOptions['audio'] = {};
          streamOptions['audio']['optional'] = [{ sourceId: selectedAudio }];
        } else {
          streamOptions['audio'] = false;
        }

        if (selectedVideo !== 'none') {
          streamOptions['video'] = {};
          streamOptions['video']['optional'] = [{ sourceId: selectedVideo }];
        } else {
          streamOptions['video'] = false;
        }
        var attachAudio = audio && !!streamOptions['audio'];
        navigator.getMedia(streamOptions, function (stream) {
          if (_this2.stream) {
            _this2.stopMedia(_this2.stream);
            _this2.stream = null;
          }
          if (_this2.audioContext) {
            _this2.audioContext.close();
            _this2.audioContext = null;
          }
          _this2.stream = stream;
          if (attachAudio) {
            _this2.attachAudioAnalyser(stream);
          }
          _this2.attachVideo(videoEl, stream);
          _this2.videoBooted = true;
        }, function (err) {
          console.error(err);
        });
      }
    }, {
      key: 'attachAudioAnalyser',
      value: function attachAudioAnalyser(stream) {
        var _this3 = this;

        var audioContext = new AudioContext();
        this.audioContext = audioContext;
        var analyser = audioContext.createAnalyser();
        var microphone = audioContext.createMediaStreamSource(stream);
        var javascriptNode = audioContext.createScriptProcessor(2048, 1, 1);

        microphone.connect(analyser);
        analyser.connect(javascriptNode);
        javascriptNode.connect(audioContext.destination);

        javascriptNode.onaudioprocess = function () {
          var array = new Uint8Array(analyser.frequencyBinCount);
          analyser.getByteFrequencyData(array);
          var values = 0;

          var length = array.length;
          for (var i = 0; i < length; i++) {
            values += array[i];
          }

          var average = values / length;

          _this3.setState(_extends({}, _this3.state, { vuMeter: average }));
          _this3.meterEnabled = true;
        };
      }
    }, {
      key: 'attachVideo',
      value: function attachVideo(element, stream) {
        if (element.srcObject !== undefined) {
          element.srcObject = stream;
        } else if (element.src !== undefined) {
          element.src = URL.createObjectURL(stream);
        } else {
          console.error('Error attaching stream to element.');
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(WrappedComponent, _extends({}, this.props, this.state));
      }
    }]);

    return _class;
  }(_react.Component);
}

Preview.PropTypes = {
  // @required
  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number.isRequired,
  // @optional
  audio: _propTypes2.default.bool,
  selectedAudio: _propTypes2.default.string,
  selectedVideo: _propTypes2.default.string,
  options: _propTypes2.default.object
};

var Video = exports.Video = function Video(props) {
  return _react2.default.createElement('video', {
    id: defaultVideoId,
    className: props.className || "video",
    height: props.height,
    width: props.width,
    autoPlay: true });
};

// @TODO: insert Volume Meter component
var VideoVUMeter = exports.VideoVUMeter = function VideoVUMeter(props) {
  return _react2.default.createElement('video', {
    id: defaultVideoId,
    className: props.className || "video",
    height: props.height,
    width: props.width,
    autoPlay: true });
};

var VideoPreview = exports.VideoPreview = Preview(Video);
var VideoAudioPreview = exports.VideoAudioPreview = Preview(VideoVUMeter);